#!/usr/bin/perl
# modified for Firefox 3 by tpg@mandriva.org
#

use File::Path;
use File::Copy;
use File::Glob ":glob";
use POSIX ":sys_wait_h";

$timeout = 60;

$ENV{HOME}="/root";
$ENV{TMP}="/tmp";
$ENV{MOZILLA_FIVE_HOME}="/opt/lib/firefox-3.5.2";
$ENV{LD_LIBRARY_PATH}="/opt/lib/firefox-3.5.2";
$ENV{MOZ_DISABLE_GNOME}="1";

umask 022;

if ( -f "/opt/lib/firefox-3.5.2/firefox-bin" )
{
    # change cache date to cause it to be dirty 
    unlink </opt/lib/firefox-3.5.2/components/*.dat>;
        
    # Register firefox
    $pid = fork();

    # I am the child.
    if ($pid == 0) {
	exec("/opt/lib/firefox-3.5.2/firefox-bin -register> /dev/null 2> /dev/null");
    }
    # I am the parent.
    else {
	my $timepassed = 0;
	do {
	    $kid = waitpid($pid, &WNOHANG);
	    sleep(1);
	    $timepassed++;
        } until $kid == -1 || $timepassed > $timeout;

	# should we kill?
	if ($timepassed > $timeout) {
	    kill (9, $pid);
	    # kill -9 can leave threads hanging around
            system("/usr/bin/killall -9 /opt/lib/firefox-3.5.2/firefox-bin");
	}
    }
}
